import { SubmitCurrencyModel } from "@/api/currency/CurrencyModle"
import { EditType } from "@/type/BaseEnum"
import { ref } from "vue"
import { addCurrencyApi,editCurrencyApi,deleteCurrencyApi } from "@/api/currency/currency"
import { Result } from "@/http/request"
import useInstance from "@/hooks/useInstance"
export default function userCurrency(getCurrencyList) {
    const { global } = useInstance();
    //定义弹框的 ref属性
    const adCurrencyRef = ref<{ show: (type: string, row?: SubmitCurrencyModel) => void }>()
    //新增
    const addBtn = () => {
        adCurrencyRef.value?.show(EditType.ADD)
    }
    //编辑
    const editBtn = (row: SubmitCurrencyModel) => {      
        adCurrencyRef.value?.show(EditType.EDIT, row)
    }
    //删除
    const deleteBtn = async (id: number) => {
        let parm = {
            id: id
        }
        //信息确认
        let confirm = await global.$myconfirm('确定删除该数据吗?')
        if (confirm) {
            let res = await deleteCurrencyApi(parm)
            if (res && res.code == 200) {
                //信息提示
                global.$message({ message: res.msg, type: 'success' })
                //刷新表格
                getCurrencyList();

            }
        }
    }
    //保存
    const save = async (parm: SubmitCurrencyModel) => {
        let res: Result;
        if (parm.type == EditType.ADD) {
            res = await addCurrencyApi(parm)
        } else {
            res = await editCurrencyApi(parm)
        }
        if (res && res.code == 200) {
            //信息提示
            global.$message({ message: res.msg, type: 'success' })
            //刷新表格
            getCurrencyList();
        }
    } 
 
    return {
        addBtn,
        editBtn,
        deleteBtn,
        save,   
        adCurrencyRef,
    }
}